// AddUser.cpp : implementation file
//

#include "stdafx.h"
#include "base.h"
#include "AddUser.h"
#include "utils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddUser dialog


CAddUser::CAddUser(CWnd* pParent /*=NULL*/)
	: CDialog(CAddUser::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddUser)
	m_bRegistryOnly = FALSE;
	//}}AFX_DATA_INIT
}


void CAddUser::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddUser)
	DDX_Control(pDX, IDC_PROFILEGROUP, m_gProfileDir);
	DDX_Check(pDX, IDC_REGISTRYONLY, m_bRegistryOnly);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddUser, CDialog)
	//{{AFX_MSG_MAP(CAddUser)
	ON_BN_CLICKED(IDC_BFINDLS, OnButtonFindLS)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddUser message handlers

BOOL CAddUser::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	return TRUE;
}

void CAddUser::OnButtonFindLS() 
{
	CString filt =	"Executables (*.exe)|*.exe|";
	CFileDialog fileDlg(TRUE,"*.exe","*.exe",NULL,filt,this);

	if (utils.bIsNT50)
	{
		fileDlg.m_ofn.lStructSize = sizeof(OPENFILENAMEEX);
	}
	fileDlg.m_ofn.Flags |= OFN_FILEMUSTEXIST;
	fileDlg.m_ofn.lpstrTitle = "Show me litestep.exe";
	if (fileDlg.DoModal() == IDOK) 
	{
		CWaitCursor bob;
		CString sDir = fileDlg.GetPathName();
		SetDlgItemText(IDC_LITESTEP,
			sDir.Left(sDir.GetLength() - fileDlg.GetFileName().GetLength())
		);
	}
}

void CAddUser::OnCancel() 
{
	CDialog::OnCancel();
}

void CAddUser::OnOK() 
{
	CString lspath;
	GetDlgItemText(IDC_LITESTEP,lspath);
	if (lspath == "")
	{
		AfxMessageBox("You didn't specified LiteStep dir!");
		return;
	}
	if (lspath.Right(1) != "\\") lspath += "\\";
	CString lsexe = lspath + "litestep.exe";
	CStdioFile f;
	if (!f.Open(lspath + "litestep.exe",CFile::modeRead))
	{
		AfxMessageBox("Cannot find " + lsexe);
		return;
	}
	f.Close();
	int where = GetCheckedRadioButton(IDC_LSPROFILE,IDC_USERPROFILE);

	char username[1024];
	char appdata[1024];
	DWORD bufsize = 1024;
	GetUserName(username,&bufsize);
	ExpandEnvironmentStrings("%appdata%",appdata,1024);

	CString profiledir;
	switch(where)
	{
	case IDC_LSPROFILE:
		profiledir = lspath + "profiles\\" + username + "\\";
		break;
	case IDC_NOUSERS:
		profiledir = lspath;
		break;
	case IDC_USERPROFILE:
		profiledir = (CString)appdata + "\\LiteStep\\";
		break;
	default:
		AfxMessageBox("Please, select path your personal files and themes to be stored in");
		return;
	}
	utils.litestepDir = lspath;
	utils.litestepExe = lspath + "litestep.exe";
	utils.personalDir = profiledir + "personal\\";
	utils.themesDir = profiledir + "themes\\";
	utils.WriteRegistry();
	if (!m_bRegistryOnly && where != IDC_NOUSERS)
	{
		CreateDirectory(profiledir, NULL);
		char from[2*(MAX_PATH+1)];
		char to[2*(MAX_PATH+1)];
		CString tmp;
		StringCchCopy(to,2*(MAX_PATH+1),profiledir);
		StringCchCopy(to+profiledir.GetLength()+1,2*MAX_PATH+1-profiledir.GetLength(),profiledir);
		to[profiledir.GetLength()*2+2] = 0;
		tmp = utils.toolDir + "lscpfiles\\personal";
		StringCchCopy(from,2*(MAX_PATH+1),tmp);
		int len = tmp.GetLength();
		tmp = utils.toolDir + "lscpfiles\\themes";
		StringCchCopy(from+len+1,2*MAX_PATH+1-len,tmp);
		from[tmp.GetLength()+len+2] = 0;
		SHFILEOPSTRUCT shfop;
		shfop.hwnd = m_hWnd;
		shfop.wFunc = FO_COPY;
		shfop.pFrom = from;
		shfop.pTo = to;
		shfop.fFlags = FOF_NOCONFIRMATION | FOF_NOCONFIRMMKDIR;
		SHFileOperation(&shfop);
	}
	CDialog::OnOK();
}
