// OptionEvars.cpp : implementation file
//

#include "stdafx.h"
#include "base.h"
#include "OptionEvars.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define LS_EVARS_NUM	51
const char *lsEvars[]=
{
	"LitestepDir",
	"AdminTools",
	"AdminToolsDir",
	"BitBucket",
	"CommonAdminToolsDir",
	"CommonDesktopDir",
	"CommonDocuments",
	"CommonFavorites",
	"CommonPrograms",
	"CommonStartMenu",
	"CommonStartUp",
	"CompileDate",
	"Controls",
	"Cookies",
	"Desktop",
	"DesktopDir",
	"Dialup",
	"Documents",
	"Drives",
	"Favorites",
	"Fonts",
	"History",
	"InternetCache",
	"NetHood",
	"Network",
	"NetworkAndDialup",
	"OS-Name",
	"OS-Version",
	"OS-MajorVersion",
	"OS-MinorVersion",
	"Printers",
	"Programs",
	"QuickLaunch",
	"Recent",
	"ResolutionX",
	"ResolutionY",
	"Scheduled",
	"SendTo",
	"StartMenu",
	"StartUp",
	"Templates",
	"Username",
	"WinDir",
	"WinME",
	"Win98",
	"Win95",
	"Win9x",
	"Win2000",
	"WinNT4",
	"WinNT",
	"WinXP"
};

char *lsEvarsDesc[] =
{
	"References the directory where the LiteStep executable is found.",
	"References the Administrative Tools folder in Windows NT/2K via the Windows Explorer interface.\r\nNote: This does not work when used in a Popup, please use $AdminToolsDir$ instead.",
	"References the Administrative Tools directory in Windows NT/2K.",
	"References the \"Recycle Bin\", which is normally found on the Explorer Desktop.",
	"References the Admin Tools for All Users for Windows NT/2K.",
	"References the Desktop folder that is shared with all users in Windows NT/2K.",
	"References the My Documents directory that is shared with all users in Windows NT/2K.",
	"References the Internet Explorer Favorites folder shared with all users in Windows NT/2K.",
	"References the Programs directory in the Start Menu shared with all users in Windows NT/2K.",
	"References the Start Menu shared with all users in Windows NT/2K.",
	"References the Start Up folder in the Start Menu that auto-runs programs at startup for all users.",
	"References the compile date of the LiteStep build.",
	"References the \"Control Panel\", which is normally in \"My Computer\".",
	"References the directory where your Internet Explorer cookies are stored.",
	"References the directory in which your files on your Windows 95/98/ME Explorer Desktop are stored.",
	"References the directory in which the current user's files on the Windows 95/98/ME Explorer Desktop icons are stored, if multiple users are configured.",
	"References the Dial-Up Networking/Connections folder that is found in your Windows 95/98/ME My Computer.",
	"References the directory named \"My Documents\" on your Hard Drive.",
	"References the \"My Computer\" folder that is found on your Explorer Desktop.",
	"References the folder that contains your Internet Explorer Favorites.",
	"References the folder that contains all of the Fonts installed in Windows.",
	"References the folder containing your Internet Explorer History.",
	"References the folder that contains all of your Temporary Internet Files.",
	"References the \"My Network Places\" in Windows 2000.",
	"References the Network Neighborhood folder found on the Explorer Desktop.",
	"References the Network and Dialup folder for Windows 2K.",
	"References the OS name.",
	"References the OS version (major.minor).",
	"References the OS major version number.",
	"References the OS minor version number.",
	"References the Printers folder that is found in both your \"Control Panel\" and \"My Computer\".",
	"References the Programs directory inside the Start Menu.\r\n(For those using NT/2K, it is the current user's Programs directory.)",
	"References the directory of the Quick Launch Bar.",
	"References the Recent Documents directory which is commonly found in the Start Menu.",
	"References the Width of the display in Pixels.",
	"References the Height of the display in Pixels.",
	"References the folder that contains Scheduled Tasks used by the Windows Task Scheduler.",
	"References the \"Send To\" folder that is found in right-click context menus.",
	"References the Start Menu folder, not to be confused with $Programs$. \r\nFor NT/2k, it is the current user's Start Menu directory.",
	"References that StartUp folder in your $Programs$, this is the directory in your Start Menu that auto-runs programs at startup.",
	"References the Templates folder.",
	"References the current username.",
	"References the installation directory of Windows.",
	"References what Operating System you are using and sets the variable to the [BOOL] value of TRUE.",
	"References what Operating System you are using and sets the variable to the [BOOL] value of TRUE.",
	"References what Operating System you are using and sets the variable to the [BOOL] value of TRUE.",
	"References what Operating System you are using and sets the variable to the [BOOL] value of TRUE.",
	"References what Operating System you are using and sets the variable to the [BOOL] value of TRUE.",
	"References what Operating System you are using and sets the variable to the [BOOL] value of TRUE.",
	"References what Operating System you are using and sets the variable to the [BOOL] value of TRUE.",
	"References what Operating System you are using and sets the variable to the [BOOL] value of TRUE."
};


#define LS_SYSINFO_EVARS_NUM	8
char *lsSysInfoEvars[] =
{
	"CompileDate",
	"OS-Name",
	"OS-Version",	
	"ResolutionX",
	"ResolutionY",	
	"UserName",
	"LitestepDir",
	"WinDir"
};

char *lsSysInfoDesc[] = 
{
	"Build compiled on:",
	"OS name:",
	"OS version:",
	"Screen Resolution X:",
	"Screen Resolution Y:",
	"User Name:",
	"Litestep Dir:",
	"Windows Dir:"
};

/////////////////////////////////////////////////////////////////////////////
// COptionEvars dialog


COptionEvars::COptionEvars(CWnd* pParent /*=NULL*/)
	: CDialog(COptionEvars::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionEvars)
	//}}AFX_DATA_INIT
}


void COptionEvars::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionEvars)
	DDX_Control(pDX, IDC_LISTINFO2, m_wndListInfo2);
	DDX_Control(pDX, IDC_EDITVARVALUE, m_wndVarValue);
	DDX_Control(pDX, IDC_EDITVARINFO, m_wndVarInfo);
	DDX_Control(pDX, IDC_COMBO1, m_wndComboVars);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionEvars, CDialog)
	//{{AFX_MSG_MAP(COptionEvars)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionEvars message handlers
BOOL COptionEvars::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	LSversion = utils.GetLSVersion();

	//listbox init
	m_wndListInfo2.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_wndListInfo2.SetHeadings( _T("Setting,110;Value,107"));

	if (settingsipc_client::IsServerPresent())
	{
		ListVars();
		ListInfo();
		OnSelchangeCombo1();
	}	
	return TRUE;
}


void COptionEvars::ListVars()
{
	for(int i=0; i<LS_EVARS_NUM; i++)
	{
		m_wndComboVars.AddString(lsEvars[i]);
	}
	m_wndComboVars.SetCurSel(0);
}


void COptionEvars::OnSelchangeCombo1() 
{
	CString evars;
	m_wndComboVars.GetLBText(m_wndComboVars.GetCurSel(), evars);

	char buf[BUFSIZE];	
	settingsipc_client::GetRCString(evars, buf, "not found/false", BUFSIZE);
	m_wndVarValue.SetWindowText(buf);

	//info
	m_wndVarInfo.SetWindowText("");
	CString m_strList = evars;
	for (int i=0; i<LS_EVARS_NUM; i++)
	{
		if (m_strList == lsEvars[i])
		{
			m_wndVarInfo.SetWindowText(lsEvarsDesc[i]);
			break;
		}
	}
}

void COptionEvars::ListInfo()
{
	char buf[BUFSIZE];
	m_wndListInfo2.AddItem("Litestep Version:", LSversion);
	for (int i=0; i<LS_SYSINFO_EVARS_NUM; i++)
	{
		settingsipc_client::GetRCString(lsSysInfoEvars[i], buf, "not found", BUFSIZE);
		m_wndListInfo2.AddItem(lsSysInfoDesc[i], buf);
	}
}
