// OptionHotkeys.cpp : implementation file
//

#include "stdafx.h"
#include "base.h"
#include "OptionHotkeys.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DWORD  __stdcall EnumerateHotkeys(void *param);

/////////////////////////////////////////////////////////////////////////////
// COptionHotkeys dialog


COptionHotkeys::COptionHotkeys(CWnd* pParent /*=NULL*/)
	: CDialog(COptionHotkeys::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionHotkeys)
	//}}AFX_DATA_INIT
}


void COptionHotkeys::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionHotkeys)
	DDX_Control(pDX, IDC_LISTHOTKEYS, m_wndListHotkeys);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionHotkeys, CDialog)
	//{{AFX_MSG_MAP(COptionHotkeys)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_WM_SHOWWINDOW()
	ON_WM_COPYDATA()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionHotkeys message handlers

BOOL COptionHotkeys::OnInitDialog() 
{
	CDialog::OnInitDialog();
	//listbox init
	m_wndListHotkeys.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_wndListHotkeys.SetHeadings("Modifiers,80;Key,80;Value,260");	
	return TRUE;
}

void COptionHotkeys::LoadText()
{
	m_wndListHotkeys.DeleteAllItems();
	if (!settingsipc_client::IsServerPresent())
	{
	}
	else
	{
		// EnumLSData must be called in a new thread since it operates with
		// Windows message queue and LoadText can be called from MessageProc too...
		DWORD thId;
		CreateThread(NULL, 0, EnumerateHotkeys, this, 0, &thId);
	}
}

void COptionHotkeys::OnRefresh() 
{
	LoadText();
}

void COptionHotkeys::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);	
	LoadText();	
}

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Separate thread for EnumLSData :)
//
DWORD  __stdcall EnumerateHotkeys(void *param)
{
	COptionHotkeys *option = (COptionHotkeys*)param;
	HRESULT hr = settingsipc_client::EnumLSData(ELD_HOTKEYS, option->m_hWnd);
	if (FAILED(hr))
	{
		option->m_wndListHotkeys.AddItem("Unknown error raised during hotkeys list processing");
	}
	return 0;
}


BOOL COptionHotkeys::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
{
	int count = * ((int*) pCopyDataStruct->lpData );
	EnumLSDataInfo *info = (EnumLSDataInfo*)((char*)pCopyDataStruct->lpData + sizeof(int));

	for (int i = 0; i < count; i++)
	{
		char *s,*p;
		char buf[1024];
		char bufs[3][1024];

		// sent string has format 'modifier|key|command'
		// we need to parse it into bufs[] array before
		// output
		StringCchCopy(buf,1024, info[i].szString);
		s = buf-1; //to be not null
		for (int i=0; i<3; i++)
		{
			p = s+1;
			s = strchr(p,'|');
			if (s)
			{
				s[0] = 0;
				StringCchCopy(bufs[i],1024,p);
			} else
			{
				StringCchCopy(bufs[i],1024,p);
				for (int j=i+1; j<3; j++)
				{
					bufs[j][0] = 0;
				}
				break;
			}
		}
		m_wndListHotkeys.AddItem(bufs[0],bufs[1],bufs[2]);
	}
	return CDialog::OnCopyData(pWnd, pCopyDataStruct);
}
