// OptionModules.cpp : implementation file
//

#include "stdafx.h"
#include "base.h"
#include "OptionModules.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DWORD  __stdcall EnumerateModules(void *param);

/////////////////////////////////////////////////////////////////////////////
// COptionModules dialog


COptionModules::COptionModules(CWnd* pParent): CDialog(COptionModules::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionModules)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void COptionModules::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionModules)
	DDX_Control(pDX, IDC_LISTUNLOADED, m_wndListUnloaded);
	DDX_Control(pDX, IDC_LISTMOD, m_wndListmod);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionModules, CDialog)
	//{{AFX_MSG_MAP(COptionModules)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_BN_CLICKED(IDC_UNLOAD, OnUnload)
	ON_BN_CLICKED(IDC_RELOAD, OnReload)
	ON_WM_SHOWWINDOW()
	ON_WM_COPYDATA()
	ON_NOTIFY(NM_DBLCLK, IDC_LISTMOD, OnDoubleClickModulesList)
	ON_LBN_DBLCLK(IDC_LISTUNLOADED, OnDoubleClickUnloadedList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionModules message handlers

BOOL COptionModules::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_wndListmod.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_wndListmod.SetHeadings( _T("Path to module,340;Threaded,60"));
	return TRUE;
}

void COptionModules::LoadText()
{
	m_wndListmod.DeleteAllItems();

	if (!settingsipc_client::IsServerPresent())
	{
		m_wndListmod.AddItem("SettingsIPC module is not loaded.","");
		m_wndListmod.AddItem("Please check your configuration.","");
	}
	else
	{
		// EnumLSData must be called in a new thread since it operates with
		// Windows message queue and LoadText can be called from MessageProc too...
		DWORD thId;
		CreateThread(NULL, 0, EnumerateModules, this, 0, &thId);
	}
}

void COptionModules::OnRefresh() 
{
	LoadText();
}

void COptionModules::OnUnload() 
{
	int q = ((int)m_wndListmod.GetFirstSelectedItemPosition()) - 1;
	CString szModule = m_wndListmod.GetItemText(q,0);
	if (szModule != "")
	{
		utils.ExecuteBang("!UnloadModule " + szModule);
		//unloaded list
		m_wndListmod.DeleteItem(q);
		m_wndListUnloaded.AddString(szModule);
	}
}

void COptionModules::OnReload() 
{
	CString szModule, szCommand;
	m_wndListUnloaded.GetText(m_wndListUnloaded.GetCurSel(), szModule);

	if (szModule != "")
	{
		szCommand = "!ReloadModule " + szModule;
		utils.ExecuteBang(szCommand);
		//reload list
		m_wndListUnloaded.DeleteString(m_wndListUnloaded.GetCurSel());
		m_wndListmod.AddItem(szModule,"");
	}
}

void COptionModules::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);	
	LoadText();	
}

void COptionModules::OnDoubleClickModulesList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnUnload();
	*pResult = 0;
}

void COptionModules::OnDoubleClickUnloadedList() 
{
	OnReload();
}

BOOL COptionModules::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
{
	int count = * ((int*) pCopyDataStruct->lpData );
	EnumLSDataInfo *info = (EnumLSDataInfo*)((char*)pCopyDataStruct->lpData + sizeof(int));
	for (int i = 0; i < count; i++)
	{
		m_wndListmod.AddItem(info[i].szString,(info[i].dwFlags & LS_MODULE_THREADED) ? "yes" : "");
	}
	return CDialog::OnCopyData(pWnd, pCopyDataStruct);
}

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Separate thread for EnumLSData :)
//
DWORD  __stdcall EnumerateModules(void *param)
{
	COptionModules *option = (COptionModules*)param;
	HRESULT hr = settingsipc_client::EnumLSData(ELD_MODULES, option->m_hWnd);
	if (FAILED(hr))
	{
		AfxMessageBox("Unknown error raised during modules list processing");
	}
	return 0;
}


