// OptionRevID.cpp : implementation file
//

#include "stdafx.h"
#include "base.h"
#include "OptionRevID.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DWORD  __stdcall EnumerateRevIDs(void *param);

/////////////////////////////////////////////////////////////////////////////
// COptionRevID dialog


COptionRevID::COptionRevID(CWnd* pParent /*=NULL*/)
	: CDialog(COptionRevID::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionRevID)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void COptionRevID::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionRevID)
	DDX_Control(pDX, IDC_LISTREVIDS, m_wndListrevids);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionRevID, CDialog)
	//{{AFX_MSG_MAP(COptionRevID)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_WM_SHOWWINDOW()
	ON_WM_COPYDATA()
	ON_LBN_DBLCLK(IDC_LISTREVIDS, OnDoubleClickRevIDsList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionRevID message handlers

void COptionRevID::LoadText()
{
	m_wndListrevids.ResetContent();

	if (!settingsipc_client::IsServerPresent())
	{
		m_wndListrevids.AddString("SettingsIPC module is not loaded.");
		m_wndListrevids.AddString("Please check your configuration.");
	}
	else
	{
		// EnumLSData must be called in a new thread since it operates with
		// Windows message queue and LoadText can be called from MessageProc too...
		DWORD thId;
		CreateThread(NULL, 0, EnumerateRevIDs, this, 0, &thId);
	}
}

void COptionRevID::OnRefresh() 
{
	LoadText();
}

void COptionRevID::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	LoadText();	
}

void COptionRevID::OnDoubleClickRevIDsList() 
{
	CString csModule;
	m_wndListrevids.GetText(m_wndListrevids.GetCurSel(), csModule);
	if (csModule != "")
	{
		utils.CopyToClipboard(m_hWnd, csModule);
	}
}

BOOL COptionRevID::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
{
	int count = * ((int*) pCopyDataStruct->lpData );
	EnumLSDataInfo *info = (EnumLSDataInfo*)((char*)pCopyDataStruct->lpData + sizeof(int));
	for (int i = 0; i < count; i++)
	{
		m_wndListrevids.AddString(info[i].szString);
	}
	return CDialog::OnCopyData(pWnd, pCopyDataStruct);
}

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Separate thread for EnumLSData :)
//
DWORD  __stdcall EnumerateRevIDs(void *param)
{
	COptionRevID *option = (COptionRevID*)param;
	HRESULT hr = settingsipc_client::EnumLSData(ELD_REVIDS, option->m_hWnd);
	if (FAILED(hr))
	{
		option->m_wndListrevids.AddString("Unknown error raised during revision IDs list processing");
	}
	return 0;
}

