// base.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "base.h"
#include "baseDlg.h"
#include "utils.h"
#include "adduser.h"
#include "themeinstaller.h"
#include "StandaloneInstaller.h"
#include "ipcconfig.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CbaseApp

BEGIN_MESSAGE_MAP(CbaseApp, CWinApp)
	//{{AFX_MSG_MAP(CbaseApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CbaseApp construction

CbaseApp::CbaseApp()
{

}

/////////////////////////////////////////////////////////////////////////////
// The one and only CbaseApp object

CbaseApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CbaseApp initialization

BOOL CbaseApp::InitInstance()
{
	SetRegistryKey("Litestep");
	LoadStdProfileSettings(9);
	
	AfxEnableControlContainer();

	if (!utils.DetermineDirs())
	{
		CAddUser dlg;
		dlg.DoModal();
	}

	// batch mode?
	if (ProcessCommandLineAndFinish())
	{
		return FALSE;
	}

	if (bInstallerOnly)
	{
		CStandaloneInstaller dlg;
		m_pMainWnd = &dlg;
		dlg.DoModal();
	}
	else
	{
		if(utils.CheckLSRunning())
		{
			if (!settingsipc_client::IsServerPresent())
			{
				CIPCConfig dlg;
				dlg.DoModal();
				switch (dlg.choice)
				{
				case WM_QUIT:
					return FALSE;
				case CHOICE_WRITEANDLOAD:
					utils.WriteOptionToRC(utils.litestepDir + "step.rc", "LoadModule \"" + utils.toolDir + "settingsipc.dll\" threaded"," ; LSCP2 library");
				case CHOICE_LOAD:
					utils.ExecuteBang("!reloadmodule \"" + utils.toolDir + "settingsipc.dll\"");
					break;
				case CHOICE_JUSTRUN:
					break;
				}
			}
		}
		CbaseDlg dlg;
		m_pMainWnd = &dlg;
		dlg.DoModal();
	}
	return FALSE;
}

bool CbaseApp::ProcessCommandLineAndFinish()
{
	themeinstaller.PrepareToolDir();
	CString cmdline = m_lpCmdLine;
	utils.TrimLeft(cmdline);
	if (strnicmp(cmdline, "/refresh", 8) == 0 || strnicmp(cmdline, "\"/refresh\"", 10) == 0)
	{
		themeinstaller.RefreshList();
		if (utils.CheckLSRunning())
		{
			utils.ExecuteBang("!recycle");
		}
		return true;
	}
	if (strnicmp(cmdline, "/switch", 7) == 0 || strnicmp(cmdline, "\"/switch\"", 9) == 0)
	{
		int pos1 = cmdline.Find(' ');
		int pos2 = cmdline.Find('\t');
		if ((pos2>0 && pos2<pos1) || pos1<0) pos1 = pos2;
		if (pos1<0)
		{
			AfxMessageBox("Cannot switch the theme:\n/switch key found, but no theme name specified");
			return true;
		}
		cmdline = cmdline.Mid(pos1);
		utils.Trim(cmdline);
		cmdline.TrimLeft('\"');
		cmdline.TrimRight('\"');
		themeinstaller.Switch(cmdline);
		return true;
	}
	if (strnicmp(cmdline, "/shell", 6) == 0 || strnicmp(cmdline, "\"/shell\"", 8) == 0)
	{
		int pos1 = cmdline.Find(' ');
		int pos2 = cmdline.Find('\t');
		if ((pos2>0 && pos2<pos1) || pos1<0) pos1 = pos2;
		if (pos1<0)
		{
			AfxMessageBox("Cannot switch the shell:\n/shell key found, but no shell name specified");
			return true;
		}
		cmdline = cmdline.Mid(pos1);
		utils.Trim(cmdline);
		cmdline.TrimLeft('\"');
		cmdline.TrimRight('\"');
		utils.SetShell(cmdline, true);
		return true;
	}
	if (cmdline != "")
	{
		cmdline.TrimLeft('\"');
		utils.Trim(cmdline);
		cmdline.TrimRight('\"');
		zip = cmdline;
		bInstallerOnly = true;
	}
	return false;
}
