// baseDlg.cpp : implementation file
//

#include "stdafx.h"
#include "base.h"
#include "baseDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const struct PageInfo
{
	char szPageName[30];
	int res_id;
} pages_info[] =
{
	{"Theme Switcher",			IDD_OPTION_THEMESWITHCER},
	{"Loaded Modules",			IDD_OPTION_LOADEDMODULES},
	{"Revision IDs",			IDD_OPTION_REVID},
	{"Loaded Bangs",			IDD_OPTION_LOADEDBANGS},
	{"Environment Variables",	IDD_OPTION_EVARS},
	{"Loaded Hotkeys",			IDD_OPTION_HOTKEYS},
	{"Log File",				IDD_OPTION_LOGFILE},
	{"Configuration Details",	IDD_OPTION_DETAILS},
	{"Changes",					IDD_OPTION_CHANGES},
	{"Help Files",				IDD_OPTION_HELPFILES},
	{"Shell Changer",			IDD_OPTION_SHELLCHANGER},
	{"Evar config",				IDD_OPTION_EVARCONFIG},
	{"Theme Installer",			IDD_OPTION_THEMEINSTALLER},
	{"Configuration files",		IDD_OPTION_CONFIGFILES}
};

/////////////////////////////////////////////////////////////////////////////
// CbaseDlg dialog

CbaseDlg::CbaseDlg(CWnd* pParent): CDialog(CbaseDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CbaseDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CbaseDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CbaseDlg)
	DDX_Control(pDX, IDC_CMDLINE, m_wndCmdline);
	DDX_Control(pDX, IDC_LSVER, m_wndLSver);
	DDX_Control(pDX, IDC_TITLEDLG, m_wndTitledlg);
	DDX_Control(pDX, IDC_MYTREE, m_tMyTree);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CbaseDlg, CDialog)
	//{{AFX_MSG_MAP(CbaseDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(TVN_SELCHANGED, IDC_MYTREE, OnSelchangedMytree)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_BTNCLOSE, OnBtnclose)
	ON_CBN_SETFOCUS(IDC_CMDLINE, OnSetfocusCmdline)
	ON_CBN_KILLFOCUS(IDC_CMDLINE, OnKillfocusCmdline)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_RECYCLELS , OnRecycleLS)
	ON_COMMAND(ID_QUITLS , OnQuitLS)
	ON_COMMAND(ID_RESTARTLS , OnRestartLS)
	ON_COMMAND(ID_RELOADLS , OnReloadLS)
	ON_COMMAND(ID_REFRESHLS , OnRefreshLS)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CbaseDlg message handlers

BOOL CbaseDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//set font and size
	m_font0.CreateFont(24,0,0,0,100,FALSE,FALSE,
	0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,
	CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
	FF_SWISS,"Verdana"); 	
	//use font
	CEdit * pEdit;
	pEdit = (CEdit *)GetDlgItem(IDC_TITLEDLG);
	pEdit->SetFont(&m_font0,FALSE);

	m_bWhite.CreateSolidBrush(GetSysColor(COLOR_WINDOW) );

	InitPages();
	
	m_wndLSver.SetWindowText("LiteStep Version: " + utils.GetLSVersion());
	
	//button menu
	m_btn.Create("!Recycle", WS_TABSTOP | WS_CHILD|WS_VISIBLE,CRect(434,427,434+90,427+23),this,ID_RECYCLELS);	
	m_btn.AddMenuItem(ID_REFRESHLS,	"Refresh LS",	0);
	m_btn.AddMenuItem(ID_RELOADLS,	"Reload LS",	0);
	m_btn.AddMenuItem(ID_RESTARTLS,	"Restart LS",	0);
	m_btn.AddMenuItem(ID_QUITLS,	"Quit LS",		0);

	//load command line history
	m_wndCmdline.LoadHistory("Settings", "HistoryCombo");

	return TRUE;
}

//initialize sub-pages and populate the tree ctrl
void CbaseDlg::InitPages()
{
	int i;
	for (i=0; i<BASE_PAGES_NUM; i++)
	{
		page_name[i] = pages_info[i].szPageName;
	}

	//create the sub-pages
	m_pDialogs[0]	=	new COptionTheme();
	m_pDialogs[1]	=	new COptionModules();
	m_pDialogs[2]	=	new COptionRevID();
	m_pDialogs[3]	=	new COptionBangs();
	m_pDialogs[4]	=	new COptionEvars();
	m_pDialogs[5]	=	new COptionHotkeys();
	m_pDialogs[6]	=	new COptionLog();
	m_pDialogs[7]	=	new COptionDetails();
	m_pDialogs[8]	=	new COptionChanges();
	m_pDialogs[9]	=	new COptionHelp();
	m_pDialogs[10]	=	new COptionShell();
	m_pDialogs[11]	=	new COptionEvarConfig();
	m_pDialogs[12]	=	new COptionInstaller();
	m_pDialogs[13]	=	new COptionProject();

	for (i=0; i<BASE_PAGES_NUM; i++)
	{
		m_pDialogs[i]->Create(pages_info[i].res_id, NULL);
		m_pDialogs[i]->ShowWindow(SW_HIDE);
	}

	m_iActiveOption = 0;

	// Create the tree.
	HTREEITEM hItem;

	hItem = m_tMyTree.InsertItem("OTS Tools",	TVI_ROOT, TVI_LAST);
	m_tMyTree.SelectItem(m_tMyTree.InsertItem(page_name[0], hItem, TVI_LAST));
	m_tMyTree.InsertItem(page_name[12], hItem,TVI_LAST);
	m_tMyTree.InsertItem(page_name[11], hItem,TVI_LAST);
	m_tMyTree.InsertItem(page_name[13], hItem,TVI_LAST);
	m_tMyTree.Expand(hItem,TVE_EXPAND);
	hItem = m_tMyTree.InsertItem("Information",	TVI_ROOT, TVI_LAST);
	m_tMyTree.InsertItem(page_name[9], hItem, TVI_LAST);
	m_tMyTree.InsertItem(page_name[8], hItem, TVI_LAST);
	m_tMyTree.InsertItem(page_name[6], hItem, TVI_LAST);
	m_tMyTree.Expand(hItem,TVE_EXPAND);
	hItem = m_tMyTree.InsertItem("Modules",		TVI_ROOT, TVI_LAST);
	m_tMyTree.InsertItem(page_name[1], hItem, TVI_LAST);
	m_tMyTree.InsertItem(page_name[2], hItem, TVI_LAST);
	m_tMyTree.Expand(hItem,TVE_EXPAND);
	m_tMyTree.InsertItem(page_name[3], TVI_ROOT, TVI_LAST);
	m_tMyTree.InsertItem(page_name[4], TVI_ROOT, TVI_LAST);
	m_tMyTree.InsertItem(page_name[5], TVI_ROOT, TVI_LAST);
	m_tMyTree.InsertItem(page_name[7], TVI_ROOT, TVI_LAST);
	m_tMyTree.InsertItem(page_name[10],TVI_ROOT, TVI_LAST);

	m_tMyTree.SetFocus();
}

//use the brush
HBRUSH CbaseDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	//control ID	
	if (pWnd->GetDlgCtrlID() == IDC_TITLEDLG)	
	{		
		pDC->SetBkColor(GetSysColor(COLOR_WINDOW));		
		return (HBRUSH)m_bWhite.GetSafeHandle();	
	}		return hbr;
}


void CbaseDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		RECT	rPositionMain;		// Main Dialog rectangle
		RECT	rPositionChild;		// Child Dialog rectangle
		int		iXDiff = 0;			// Left-Right change
		int		iYDiff = 0;			// Up-Down change

		GetWindowRect(&rPositionMain);	// Get the rectangle the dialog occupies

		// Based on the button pushed...
		if (m_iActiveOption >= 0 && m_iActiveOption < BASE_PAGES_NUM)
		{
			m_pDialogs[m_iActiveOption]->GetWindowRect(&rPositionChild);	// Get the child rectangle
			if (rPositionChild.top != 50)			// If the top side of the child is not correctly positioned...
			{
				iYDiff = 50 - rPositionChild.top;	// ...move the top and bottom sides of the child appropriately
				rPositionChild.top += iYDiff;
				rPositionChild.bottom += iYDiff;
			}
			if (rPositionChild.left != 158)			// If the left side of the child is not correctly positioned...
			{
				iXDiff = 158 - rPositionChild.left;	// ...move the left and right sides of the child appropriately
				rPositionChild.left += iXDiff;
				rPositionChild.right += iXDiff;
			}
			if (iXDiff != 0 || iYDiff != 0)			// If we moved the child...
			{
				m_pDialogs[m_iActiveOption]->MoveWindow(&rPositionChild, TRUE);		// ...make the move!
			}
			m_pDialogs[m_iActiveOption]->ShowWindow(SW_SHOW);		// Show the child dialog
		}
	}
}

// The system calls this to obtain the cursor to display while the user drags
// the minimized window.
HCURSOR CbaseDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CbaseDlg::OnSelchangedMytree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	
	HTREEITEM		hItem;
	CString			szOptionChosen;

	hItem = m_tMyTree.GetSelectedItem();	// Get a Handle to the newly selected item.
	szOptionChosen = m_tMyTree.GetItemText(hItem);	// Get the text of the chosen option.	
	
	if (m_iActiveOption>=0 && m_iActiveOption<BASE_PAGES_NUM)
	{
		m_pDialogs[m_iActiveOption]->ShowWindow(SW_HIDE);
	}

	*pResult = 0;
	GetDlgItem(IDC_TITLEDLG)->SetWindowText("  LSCP2 - " + szOptionChosen);
	for (int i=0; i<BASE_PAGES_NUM; i++)
	{
		if (szOptionChosen == page_name[i])	// If this option was chosen...
		{
			m_iActiveOption = i;
			OnPaint();
			return;
		}
	}
}

//close and history etc
void CbaseDlg::OnBtnclose() 
{
	((COptionShell*)(m_pDialogs[10]))->WriteRegistry();
	m_wndCmdline.SaveHistory();
	OnCancel();
}

void CbaseDlg::OnOK()
{
	//only if the command line is selected
	if (m_bCmdFocus)
	{
		CString sItem;
		m_wndCmdline.GetWindowText(sItem);
		m_wndCmdline.AddString(sItem);
		m_wndCmdline.SaveHistory();

		// Get the string from the EDIT control
		CString sCommand;
		m_wndCmdline.GetWindowText(sCommand);

		// Parse out the Command
		int nCmdLen = sCommand.Find(__TEXT(' '));
		//Check the first character
		CString sCheck;
		sCheck = sCommand[0];
		
		if (nCmdLen == -1)
		{
			nCmdLen = sCommand.GetLength();
		}
		//It is not a !bang
		if (sCheck == "!")	//is it a !bang?
			utils.ExecuteBang(sCommand);
		else
		{
			// Parse out the parameters to pass to the Command
			CString sParams = sCommand.Mid(nCmdLen);
			utils.TrimLeft(sParams);

			// Have the Shell run our command with its parameters
			HINSTANCE hinst = ::ShellExecute(m_hWnd, NULL, sCommand.Left(nCmdLen), sParams, NULL, SW_SHOWNORMAL);
   
			if (hinst < (HINSTANCE) HINSTANCE_ERROR)
			{
				// If the command failed to run, tell the user.
				MessageBox("Unable to execute command", "Litestep Control Panel", MB_ICONSTOP | MB_OK);
			}
		}
	}
}

void CbaseDlg::OnSetfocusCmdline() 
{
	m_bCmdFocus = true;
}

void CbaseDlg::OnKillfocusCmdline() 
{
	m_bCmdFocus = false;	
}

void CbaseDlg::OnRecycleLS()
{
	utils.ExecuteBang("!recycle");
}

void CbaseDlg::OnQuitLS()
{
	utils.ExecuteBang("!quit");
}

void CbaseDlg::OnRestartLS()
{
	utils.ExecuteBang("-nostartup");
}

void CbaseDlg::OnRefreshLS()
{
	utils.ExecuteBang("!refresh");
}

void CbaseDlg::OnReloadLS()
{
	utils.ExecuteBang("!reload");
}
